
import java.lang.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
/**
 * ChunkedHelloWorld́A`NijƂHTTP̃{fB쐬TvłB
 * pڑɑΉ̍쐬ɗLpłB
 * 쐬 : (01/05/21 13:31:36)
 * @author: Terry
 */
public class ChunkedHelloWorld extends HttpServlet {
/**
 * Process incoming HTTP GET requests 
 */
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	performTask(request, response);
}
/**
 * Process incoming HTTP POST requests 
 */
public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	performTask(request, response);
}
/**
 * {T[ubg̕ԂB
 */
public String getServletInfo() {
	return "ChunkedHelloWorld for Persistent-Connection evaluation, Version 1.0 by Terry";
}
/**
 * ChunkedHelloWorld̗vł́A{ꍬHTMLeLXgOutputStreamWriter
 * oCgf[^ɕϊByteArrayOutputStreamobt@ɒ~ςB̃obt@̃TCY
 * oCgTCYmă`N쐬łB
 */
public void performTask(HttpServletRequest request, HttpServletResponse response) {

	try

	{
		
		//vgRw\ł͂܂ł
//		response.setHeader("Protocol", "HTTP/1.1");
		
		response.setContentType("text/html");
		//KvȂ炱ɕZbgwȉ̂悤ɒǉ
//		response.setContentType("text/html; charaset=Shift_JIS");

		//{fB`Nhł邱Ƃwb_sŒm点
		response.setHeader("Transfer-Encoding", "Chunked");

		//KvȂ炱TCPڑ̊J(Close)p(Keep-Alive)s
		response.setHeader("Connection", "Keep-Alive");

		//oCgo͗pOutputStream̎擾
		OutputStream os = response.getOutputStream();
		
		//oCgϊf[^̗pXg[pӂ
		ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
		//w肵TCÝAs玩IɊg傳			
		
		//oCgf[^ꎞޔpXg[pӂ
		ByteArrayOutputStream bytes = new ByteArrayOutputStream(1024);
		//w肵TCÝAs玩IɊg傳
		
		//oCgɕϊ̂߂OutputStreamWriter̎擾
		OutputStreamWriter osw = new OutputStreamWriter(baos, "Shift_JIS");
		System.out.println("OutputStreamWriter.getEncoding: " + osw.getEncoding());
		//GR[fBO"Shift_JIS""ISO-2022-JP""EUC-JP"Ȃǂw肷
		//ftHg̃TCY8192oCgł

		//XBufferdWriterŕŃR[hRo[^write()ɌĂ΂Ȃ悤ɂ
		Writer out = new BufferedWriter(osw);
		//ftHg̃TCY8192oCgł

		//HTMLy[W̍ŏ̋̕Lq
		out.write("<HTML>");
		out.write("<HEAD><TITLE>Chunked Hello World: Part 1</TITLE></HEAD>");
		out.write("<BODY><BIG>Chunked Hello World from NX (Part 1)</BIG></BODY>");

		//ϊƃoCg`ŃoCgA[obt@ւ̈ڂ
		out.flush();
//		osw.flush();	//flush()̓`dɂsvł̂ō㏑Ȃ

		//ŏ̃`N̑ޔ
		baos.writeTo(bytes);

		//ŏ̃`ÑTCY\s̓
		out.write(Integer.toHexString(baos.size())+"\r\n");
		baos.reset();
		out.flush();
		bytes.writeTo(baos);
		bytes.reset();

		//ŏ̃`N𑗐Mobt@ɈڂĂR~bg
		System.out.println("ByteArrayOutputStream: " + bytes.toString());
		baos.writeTo(os);
		baos.reset();
		os.flush();
		
		//HTMLy[W̍Ō̋̕Lq
		out.write("<HEAD><TITLE>Chunked Hello World: Part 1</TITLE></HEAD>");
		out.write("<BODY><BIG>Chunked Hello World from NX (Part 2)</BIG></BODY>");
		out.write("</HTML>");
			
		//ϊƃoCg`ŃoCgA[obt@ւ̈ڂ
		out.flush();

		//Ō̃`N̑ޔ
		baos.writeTo(bytes);

		//Ō̃`ÑTCY\s̓
		out.write("\r\n"+Integer.toHexString(baos.size())+"\r\n");
		baos.reset();
		out.flush();
		bytes.writeTo(baos);
		bytes.reset();

		//ŏI`N\sƃpPbgI̋󔒍s
		out.write("\r\n0\r\n\r\n");
		out.flush();

		//Ō̃`NƏIs𑗐Mobt@ɈڂĂR~bg
		System.out.println("ByteArrayOutputStream: " + bytes.toString());
		baos.writeTo(os);
		baos.reset();
		os.flush();
		
		//SẴobt@̃N[Y
		out.close();
		osw.close();
		bytes.close();
		os.close();
		response.flushBuffer();
	}
	catch(UnsupportedEncodingException e){
			System.err.println("Encoding not supported: " + e.getMessage());
	}
	catch(IOException e)
	{
			System.err.println("IOException during AnotherHelloWorld.performTask: " + e.getMessage());
	}
}
}
