
import java.io.*;
import java.util.zip.*;
import javax.servlet.*;
import javax.servlet.http.*;
/**
 * CompressedFileTransferT[ubǵANCAgȉ̂悤URL󂯕t
 * http://localhost:8080/CompressedFileTransfer?Hello
 * T[ubgCompressedFileTransfer\ɂHello.doct@CT
 * kăNCAgɑB
 * F@ݑΉuEUIÊ݂łB
 * @@@܂AgetRealPath𐳂̂WebsphereT[ô݂ł̂ŁA
 * @@@ȊÕGW̏ꍇ̓t@C̎w@ɎKvB
 * @@@̂悤Ȏg̏ꍇ̓ZLeBɒӂ邱ƁB
 * 쐬 : (01/06/12 15:43:52)
 * @author: Terry
 */
public class CompressedFileTransfer extends HttpServlet {
/**
 * Process incoming HTTP GET requests 
 */
public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	performTask(request, response);
}
/**
 * Process incoming HTTP POST requests 
 */
public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	performTask(request, response);
}
/**
 * {T[ubg̕ԂB
 */
public String getServletInfo() {
	return "CompressedFileTransfer for zipped Word file transfer, Version 1.0 by Terry";
}
/**
 * ̃T[ubg̓NGŎw肳ꂽt@Ci.doc͕tȂƁjWordt@CT
 * kHTTPpPbgƂă[UɕԂ
 */
public void performTask(HttpServletRequest request, HttpServletResponse response) {

	try

	{
		FileInputStream fis;
		OutputStream os;
		ByteArrayOutputStream baos;
		GZIPOutputStream gzipos;

		String accepttypes = request.getHeader("Accept");		//Acceptwb_ŃuEUMSwordΉׂ
        if ((accepttypes != null)
            && (accepttypes.indexOf("application/msword") != -1)) {
        response.setHeader("Content-Type","application/msword");//Content-Typewordł邱ƂuEUɒʒm
        response.setHeader("Accept-Ranges","bytes");			//Ȃ̃wb_Kvł
        }
        else {
			throw new Exception("Ȃ̃uEUMS-WordT|[gĂ܂");
        }
				
		String fileName = request.getQueryString() + ".doc";	//NG񂩂̃t@Cƃt@C^Cv
		ServletContext context = getServletContext();			//ReLXg擾
		String fileDirectory = context.getRealPath(request.getRequestURI());	//̃\bhWTEł͐@\
		String file = fileDirectory + "\\" + fileName;			//fBNgۂ̃t@CAhX

		try {
			fis = new FileInputStream(file);					//t@CJ
		}catch(IOException noSuchFile) {
			throw new FileNotFoundException("t@CႢ܂BNGȂĂiF?HelloWorldj");
		}

        String acceptedEncodings = request.getHeader("Accept-Encoding");
        if ((acceptedEncodings != null)							//uEUGZIPΉׂ
            && (acceptedEncodings.indexOf("gzip") != -1)) {
	        os = response.getOutputStream();					//GWւ̏o̓Xg[
	        baos = new ByteArrayOutputStream();					//oCgm邽߂̃oCgobt@
            gzipos = new GZIPOutputStream(baos);				//GZIPk̃GR[_
            response.setHeader("Content-Encoding", "gzip");		//uEUgzipł邱Ƃ̒ʒm
        }
        else {
			throw new Exception("Ȃ̃uEUgzipkT|[gĂ܂");
        }

        int totalBytesRead = 0;
        byte[] buffer = new byte[4096];							//4096oCg̃oCgobt@p
        while (true) {
	        int bytesRead = fis.read(buffer);					//obt@̍őeʂ܂œǂݍ
        	if (bytesRead == -1) break;							//EOFɒB̃`FbN
        	gzipos.write(buffer, 0, bytesRead);					//obt@GZIPo̓Xg[֏o
 			totalBytesRead = totalBytesRead + bytesRead;
        }        
        fis.close();											//t@C̓eSēǂݏo
        gzipos.finish();										//GZIPGR[hI
        gzipos.close();											//CRC܂߃oCgobt@ɗ

        	
        response.setContentLength(baos.size());					//HTTP{fB̃oCgʒm
        System.out.println("File: " + file);
        System.out.println("Original byte size: " + totalBytesRead);
        System.out.println("Compressed byte size: " + baos.size());
        baos.writeTo(os);										//{fBo̓Xg[Ɉڂ
        baos.close();											//IɃoCgobt@
        os.close();												//IɂtbVĕ
        response.flushBuffer();									//IR~bg
	}
	catch(FileNotFoundException e)
	{
		e.printStackTrace();
		try{
		response.sendError(HttpServletResponse.SC_NOT_FOUND, e.getMessage());
		}
		catch (IOException anotherException){anotherException.printStackTrace();}
	}
	catch(Exception e)
	{
		e.printStackTrace();
		try{
		response.sendError(HttpServletResponse.SC_METHOD_NOT_ALLOWED, e.getMessage());
		}
		catch (IOException anotherException){anotherException.printStackTrace();}
	}
	}
}
